Index: /trunk/LMDZ.MARS/README
===================================================================
--- /trunk/LMDZ.MARS/README	(revision 657)
+++ /trunk/LMDZ.MARS/README	(revision 658)
@@ -1665,2 +1665,15 @@
 - aeronomars/conc.h : cleanup of obsolete variables
 - aeronomars/chimiedata.h : cleanup of obsolete variables
+
+== 12/05/12 == FGG+JYC+EM
+- updated high atmosphere photochemistry (jthermcalc.F, param_v4.h, iono.h,
+  paramfoto_compact.F, param_read.F , thermosphere.F).
+- minor change in calchim.F90 (to not use maxloc(zycol, dim = 2) function
+  which seems to be a problem for g95) .
+- minor bug fix in perosat.F; set tendency on pdqscloud for h2o2 to zero if
+  none is computed.
+- in "moldiff.F", changed "tridag" to "tridag_sp", "LUBKSB" to "LUBKSB_SP"
+  and "LUDCMP" to "LUDCMP_SP" to avoid possible conflicts with same routines
+  defined in "moldiff_red.F". Added use of automatic-sized array in "tridag"
+  and "tridag_sp" local array "gam" (to avoid using an a priori oversized
+  local array).
Index: /trunk/LMDZ.MARS/libf/aeronomars/calchim.F90
===================================================================
--- /trunk/LMDZ.MARS/libf/aeronomars/calchim.F90	(revision 657)
+++ /trunk/LMDZ.MARS/libf/aeronomars/calchim.F90	(revision 658)
@@ -95,5 +95,5 @@
       integer,save :: nbq                   ! number of tracers used in the chemistry
       integer,save :: niq(nqmx)             ! array storing the indexes of the tracers
-      integer :: major(nlayermx)            ! index of major species
+      integer :: iloc(1)            ! index of major species
       integer :: ig,l,i,iq,iqmax
       integer :: foundswitch, lswitch
@@ -171,5 +171,4 @@
             call read_phototable
          end if
-
          ! find index of chemical tracers to use
          ! Listed here are all tracers that can go into photochemistry
@@ -660,5 +659,4 @@
                             zu, zv, zt, zycol, ptimestep, co2ice)
          end if
-
 !=======================================================================
 !     tendencies
@@ -667,10 +665,10 @@
 !     index of the most abundant species at each level
 
-         major(:) = maxloc(zycol, dim = 2)
+!         major(:) = maxloc(zycol, dim = 2)
 
 !     tendency for the most abundant species = - sum of others
-
          do l = 1,nlayermx
-            iqmax = major(l)
+            iloc=maxloc(zycol(l,:))
+            iqmax=iloc(1)
             do i = 1,nbq
                iq = niq(i) ! get tracer index
@@ -683,5 +681,4 @@
             end do
          end do ! of do l = 1,nlayermx
-!         if(ig.eq.800)write(*,*)'calchim/686',dqchim(ig,27,23)
 
 !=======================================================================
Index: /trunk/LMDZ.MARS/libf/aeronomars/iono.h
===================================================================
--- /trunk/LMDZ.MARS/libf/aeronomars/iono.h	(revision 657)
+++ /trunk/LMDZ.MARS/libf/aeronomars/iono.h	(revision 658)
@@ -19,29 +19,29 @@
      $ taunoplus,taun2plus,tauhplus,tauhco2plus
 
-      real*8    tauco2(nlayermx,nreact)
-      real*8    tauo2(nlayermx,nreact)
-      real*8    tauo3p(nlayermx,nreact)
-      real*8    tauco(nlayermx,nreact)
-      real*8    tauh(nlayermx,nreact)
-      real*8    tauoh(nlayermx,nreact)
-      real*8    tauho2(nlayermx,nreact)
-      real*8    tauh2(nlayermx,nreact)
-      real*8    tauh2o(nlayermx,nreact)
-      real*8    tauo1d(nlayermx,nreact)
-      real*8    tauh2o2(nlayermx,nreact)
-      real*8    tauo3(nlayermx,nreact)
-      real*8    taun(nlayermx,nreact)
-      real*8    tauno(nlayermx,nreact)
-      real*8    taun2(nlayermx,nreact)
-      real*8    taun2d(nlayermx,nreact)
-      real*8    tauno2(nlayermx,nreact)
-      real*8    tauco2plus(nlayermx,nreact)
-      real*8    tauoplus(nlayermx,nreact)
-      real*8    tauo2plus(nlayermx, nreact)
-      real*8    taucoplus(nlayermx, nreact)
-      real*8    taucplus(nlayermx, nreact)
-      real*8    taunplus(nlayermx, nreact) 
-      real*8    taunoplus(nlayermx, nreact)
-      real*8    taun2plus(nlayermx, nreact)
-      real*8    tauhplus(nlayermx, nreact)
-      real*8    tauhco2plus(nlayermx, nreact)
+      real*8    tauco2(nreact,nlayermx)
+      real*8    tauo2(nreact,nlayermx)
+      real*8    tauo3p(nreact,nlayermx)
+      real*8    tauco(nreact,nlayermx)
+      real*8    tauh(nreact,nlayermx)
+      real*8    tauoh(nreact,nlayermx)
+      real*8    tauho2(nreact,nlayermx)
+      real*8    tauh2(nreact,nlayermx)
+      real*8    tauh2o(nreact,nlayermx)
+      real*8    tauo1d(nreact,nlayermx)
+      real*8    tauh2o2(nreact,nlayermx)
+      real*8    tauo3(nreact,nlayermx)
+      real*8    taun(nreact,nlayermx)
+      real*8    tauno(nreact,nlayermx)
+      real*8    taun2(nreact,nlayermx)
+      real*8    taun2d(nreact,nlayermx)
+      real*8    tauno2(nreact,nlayermx)
+      real*8    tauco2plus(nreact,nlayermx)
+      real*8    tauoplus(nreact,nlayermx)
+      real*8    tauo2plus(nreact,nlayermx)
+      real*8    taucoplus(nreact,nlayermx)
+      real*8    taucplus(nreact,nlayermx)
+      real*8    taunplus(nreact,nlayermx) 
+      real*8    taunoplus(nreact,nlayermx)
+      real*8    taun2plus(nreact,nlayermx)
+      real*8    tauhplus(nreact,nlayermx)
+      real*8    tauhco2plus(nreact,nlayermx)
Index: /trunk/LMDZ.MARS/libf/aeronomars/jthermcalc.F
===================================================================
--- /trunk/LMDZ.MARS/libf/aeronomars/jthermcalc.F	(revision 657)
+++ /trunk/LMDZ.MARS/libf/aeronomars/jthermcalc.F	(revision 658)
@@ -32,6 +32,4 @@
 c    local parameters and variables
 
-      real       aux1(nlayermx)	                !auxiliar variable
-      real       aux2(nlayermx)                 !auxiliar variable
       real       co2colx(nlayermx)              !column density of CO2 (cm^-2)
       real       o2colx(nlayermx)               !column density of O2(cm^-2)
@@ -57,15 +55,34 @@
 
 
-
 c     variables used in interpolation
 
-      real aux3(nz2), aux4(nz2)
-                                              !auxiliar variables
-      real       limdown                      !limits for interpolation
-      real       limup                        !        ""
+      real*8      auxcoltab(nz2)
+      real*8      auxjco2(nz2)
+      real*8      auxjo2(nz2)
+      real*8      auxjo3p(nz2)
+      real*8      auxjh2o(nz2)
+      real*8      auxjh2(nz2)
+      real*8      auxjh2o2(nz2)
+      real*8      auxjo3(nz2)
+      real*8      auxjn2(nz2)
+      real*8      auxjn(nz2)
+      real*8      auxjno(nz2)
+      real*8      auxjco(nz2)
+      real*8      auxjh(nz2)
+      real*8      auxjno2(nz2)
+      real*8      wp(nlayermx),wm(nlayermx)
+      real*8      auxcolinp(nlayermx)
+      integer     auxind(nlayermx)
+      integer     auxi
+      integer     ind
+      real*8      cortemp(nlayermx)
+
+      real*8      limdown                      !limits for interpolation
+      real*8      limup                        !        ""
 
       !!!ATTENTION. Here i_co2 has to have the same value than in chemthermos.F90
       !!!If the value is changed there, if has to be changed also here !!!!
       integer,parameter :: i_co2=1
+
 
 c*************************PROGRAM STARTS*******************************
@@ -117,30 +134,20 @@
 ! in each spectral interval
 
-!AQUI SE PODRIAN AGRUPAR CALCULOS PARA AHORRAR TIEMPO DE CPU
-!P.EJ. LOS CALCULOS DE AUX2 y AUX4 NO ES NECESARIO REPETIRLOS
-!PARA CADA ESPECIE EN UN INTERVALO.
-!REVISAR
-
-!TAMBIEN SE PODRIA PONER, EN LUGAR DE CONDICIONES SOBRE CHEMTHERMOD
-!PARA VER QUE ESPECIES SE CONSIDERAN, PONER CONDICION SOBRE LA EXISTENCIA DE 
-!CADA ESPECIE EN TRACEUR.DEF. ASI SE CALCULARIA LA FOTOABSORCION DE TODAS LAS
-!ESPECIES INCLUIDAS, AUNQUE LUEGO NO SE TENGA EN CUENTA EN LA QUIMICA (P.EJ.,
-!SI HAY NO2 PERO NO NO, NO SE CALCULARIA QUIMICA DEL NITROGENO PERO SE PODRIA
-!TENER EN CUENTA PARA EL CALENTAMIENTO
-!ESTUDIAR EN EL FUTURO
-
-!OTRA POSIBILIDAD ES SUSTITUIR LA ESCRITURA EN DURO DE LOS INDICES
-!DE LAS ESPECIES EN JABSIFOTS, CRSCABSI, ETC. POR INDICES DEL TIPO I_*
-!ESTUDIAR EN EL FUTURO
-c************************************************
-c     co2,0.1,6.0
-c************************************************
-
+
+c     auxcolinp-> Actual atmospheric column
+c     auxj*-> Tabulated photoabsorption coefficients
+c     auxcoltab-> Tabulated atmospheric columns
+
+ccccccccccccccccccccccccccccccc
+c     0.1,5.0 (int 1)
+c
+c     Absorption by: 
+c     CO2, O2, O, H2, N
+ccccccccccccccccccccccccccccccc
+
+c     Input atmospheric column
       indexint=1
-      limdown=1e-20
-      limup=1e26
-      do i=1,nlayermx
-         aux1(i)=0.
-         aux2(nlayermx-i+1) = co2colx(i)*crscabsi2(1,indexint) +
+      do i=1,nlayermx
+         auxcolinp(nlayermx-i+1) = co2colx(i)*crscabsi2(1,indexint) +
      $        o2colx(i)*crscabsi2(2,indexint) + 
      $        o3pcolx(i)*crscabsi2(3,indexint) + 
@@ -148,132 +155,75 @@
      $        ncolx(i)*crscabsi2(9,indexint)
       end do
+      limdown=1.e-20
+      limup=1.e26
+
+
+c     Interpolations
+
       do i=1,nz2
-         aux3(i) = jabsifotsintpar(indexint,1,nz2-i+1)
-         aux4(i) = c1_16(nz2-i+1,indexint)
+         auxi = nz2-i+1
+         !CO2 tabulated coefficient
+         auxjco2(i) = jabsifotsintpar(auxi,1,indexint)
+         !O2 tabulated coefficient
+         auxjo2(i) = jabsifotsintpar(auxi,2,indexint)
+         !O3p tabulated coefficient
+         auxjo3p(i) = jabsifotsintpar(auxi,3,indexint)
+         !H2 tabulated coefficient
+         auxjh2(i) = jabsifotsintpar(auxi,5,indexint)
+         !Tabulated column
+         auxcoltab(i) = c1_16(auxi,indexint)
       enddo
-
-      call interpfast 
-     $     (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
-      do i=1,nlayermx
-         jfotsout(indexint,1,i) = aux1(nlayermx-i+1)
+      !Only if chemthermod.ge.2
+      !N tabulated coefficient
+      if(chemthermod.ge.2) then
+         do i=1,nz2
+            auxjn(i) = jabsifotsintpar(nz2-i+1,9,indexint)
+         enddo
+      endif
+
+      call interfast 
+     $     (wm,wp,auxind,auxcolinp,nlayermx,auxcoltab,nz2,limdown,limup)
+      do i=1,nlayermx
+         ind=auxind(i)
+         auxi=nlayermx-i+1
+         !CO2 interpolated coefficient
+         jfotsout(indexint,1,auxi) = wm(i)*auxjco2(ind+1) +
+     $        wp(i)*auxjco2(ind)
+         !O2 interpolated coefficient
+         jfotsout(indexint,2,auxi) = wm(i)*auxjo2(ind+1) +
+     $        wp(i)*auxjo2(ind)
+         !O3p interpolated coefficient
+          jfotsout(indexint,3,auxi) = wm(i)*auxjo3p(ind+1) +
+     $        wp(i)*auxjo3p(ind)
+          !H2 interpolated coefficient
+          jfotsout(indexint,5,auxi) = wm(i)*auxjh2(ind+1) +
+     $         wp(i)*auxjh2(ind)
       enddo
-
-c************************************************
-c     o2,0.1,6.0
-c************************************************
-
-      indexint=1
-      limdown=1e-20
-      limup=1e26
-      do i=1,nlayermx
-         aux1(i)=0.
-         aux2(nlayermx-i+1) =  co2colx(i)*crscabsi2(1,indexint) +
-     $        o2colx(i)*crscabsi2(2,indexint) + 
-     $        o3pcolx(i)*crscabsi2(3,indexint) + 
-     $        h2colx(i)*crscabsi2(5,indexint) + 
-     $        ncolx(i)*crscabsi2(9,indexint)
-      end do
-      do i=1,nz2
-         aux3(i) = jabsifotsintpar(indexint,2,nz2-i+1)
-         aux4(i) = c1_16(nz2-i+1,indexint)
-      enddo
-
-      call interpfast 
-     $     (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
-      do i=1,nlayermx
-         jfotsout(indexint,2,i) = aux1(nlayermx-i+1)
-      enddo
-
-c**************************************************         
-c     o3p,0.1,6.0
-c**************************************************
-
-      indexint=1
-      limdown=1e-20
-      limup=1e26
-      do i=1,nlayermx
-         aux2(nlayermx-i+1) =  co2colx(i)*crscabsi2(1,indexint) +
-     $        o2colx(i)*crscabsi2(2,indexint) + 
-     $        o3pcolx(i)*crscabsi2(3,indexint) + 
-     $        h2colx(i)*crscabsi2(5,indexint) + 
-     $        ncolx(i)*crscabsi2(9,indexint)
-      end do
-      do i=1,nz2
-         aux3(i) = jabsifotsintpar(indexint,3,nz2-i+1)
-         aux4(i) = c1_16(nz2-i+1,indexint)
-      enddo
-      call interpfast 
-     $     (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
-      do i=1,nlayermx
-         jfotsout(indexint,3,i) = aux1(nlayermx-i+1)
-      enddo
-
-      
-c**************************************************
-c     h2,0.1,6.0
-c**************************************************
-
-      indexint=1
-      limdown=1e-20
-      limup=1e26
-      do i=1,nlayermx
-         aux2(nlayermx-i+1) =  co2colx(i)*crscabsi2(1,indexint) +
-     $        o2colx(i)*crscabsi2(2,indexint) + 
-     $        o3pcolx(i)*crscabsi2(3,indexint) + 
-     $        h2colx(i)*crscabsi2(5,indexint) + 
-     $        ncolx(i)*crscabsi2(9,indexint)
-      end do
-      do i=1,nz2
-         aux3(i) = jabsifotsintpar(indexint,5,nz2-i+1)
-         aux4(i) = c1_16(nz2-i+1,indexint)
-      enddo
-      call interpfast 
-     $     (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
-      do i=1,nlayermx
-         jfotsout(indexint,5,i) = aux1(nlayermx-i+1)
-      enddo
-
-      !Only if Nitrogen or ionospheric chemistry requested
+      !Only if chemthermod.ge.2
+      !N interpolated coefficient
       if(chemthermod.ge.2) then
-
-c**************************************************
-c     n,0.1,6.0
-c**************************************************
-
-
-         indexint=1
-         limdown=1e-20
-         limup=1e26
          do i=1,nlayermx
-            aux2(nlayermx-i+1) =  co2colx(i)*crscabsi2(1,indexint) +
-     $           o2colx(i)*crscabsi2(2,indexint) + 
-     $           o3pcolx(i)*crscabsi2(3,indexint) + 
-     $           h2colx(i)*crscabsi2(5,indexint) + 
-     $           ncolx(i)*crscabsi2(9,indexint)
-         end do
-         do i=1,nz2
-            aux3(i) = jabsifotsintpar(indexint,9,nz2-i+1)
-            aux4(i) = c1_16(nz2-i+1,indexint)
-         enddo
-         call interpfast 
-     $        (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
+            ind=auxind(i)
+            jfotsout(indexint,9,nlayermx-i+1) =  wm(i)*auxjn(ind+1) +
+     $         wp(i)*auxjn(ind)
+         enddo
+      endif
+         
+
+c     End interval 1
+
+
+ccccccccccccccccccccccccccccccc
+c     5-80.5nm (int 2-15)
+c
+c     Absorption by:
+c     CO2, O2, O, H2, N2, N, 
+c     NO, CO, H, NO2
+ccccccccccccccccccccccccccccccc
+
+c     Input atmospheric column
+      do indexint=2,15
          do i=1,nlayermx
-            jfotsout(indexint,9,i) = aux1(nlayermx-i+1)
-         enddo
-
-      endif  !Of chemthermod >= 2
-      
-
-c**************************************************
-c     o2, 5-80.5nm
-c**************************************************
-
-      limdown=1e-20
-      limup=1e26
-      do indexint=2,15
-         do i=nlayermx-1,1,-1
-         end do
-         do i=1,nlayermx
-            aux2(nlayermx-i+1) = co2colx(i)*crscabsi2(1,indexint)+
+            auxcolinp(nlayermx-i+1) = co2colx(i)*crscabsi2(1,indexint)+
      $           o2colx(i)*crscabsi2(2,indexint)+
      $           o3pcolx(i)*crscabsi2(3,indexint)+
@@ -286,286 +236,99 @@
      $           no2colx(i)*crscabsi2(13,indexint)
          end do
+
+c     Interpolations
+
          do i=1,nz2
-            aux3(i) = jabsifotsintpar(indexint,2,nz2-i+1)
-            aux4(i) = c1_16(nz2-i+1,indexint)
-         enddo
-          call interpfast 
-     $        (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
+            auxi = nz2-i+1
+            !O2 tabulated coefficient
+            auxjo2(i) = jabsifotsintpar(auxi,2,indexint)
+            !O3p tabulated coefficient
+            auxjo3p(i) = jabsifotsintpar(auxi,3,indexint)
+            !CO2 tabulated coefficient
+            auxjco2(i) = jabsifotsintpar(auxi,1,indexint)
+            !H2 tabulated coefficient
+            auxjh2(i) = jabsifotsintpar(auxi,5,indexint)
+            !N2 tabulated coefficient
+            auxjn2(i) = jabsifotsintpar(auxi,8,indexint)
+            !CO tabulated coefficient
+            auxjco(i) = jabsifotsintpar(auxi,11,indexint)
+            !H tabulated coefficient
+            auxjh(i) = jabsifotsintpar(auxi,12,indexint)
+            !tabulated column
+            auxcoltab(i) = c1_16(auxi,indexint)
+         enddo
+         !Only if chemthermod.ge.2
+         if(chemthermod.ge.2) then
+            do i=1,nz2
+               auxi = nz2-i+1
+               !N tabulated coefficient
+               auxjn(i) = jabsifotsintpar(auxi,9,indexint)
+               !NO tabulated coefficient
+               auxjno(i) = jabsifotsintpar(auxi,10,indexint)
+               !NO2 tabulated coefficient
+               auxjno2(i) = jabsifotsintpar(auxi,13,indexint)
+            enddo
+         endif
+
+          call interfast(wm,wp,auxind,auxcolinp,nlayermx,
+     $        auxcoltab,nz2,limdown,limup)
           do i=1,nlayermx
-            jfotsout(indexint,2,i) = aux1(nlayermx-i+1) 
+             ind=auxind(i)
+             auxi = nlayermx-i+1
+             !O2 interpolated coefficient
+             jfotsout(indexint,2,auxi) = wm(i)*auxjo2(ind+1) +
+     $            wp(i)*auxjo2(ind)
+             !O3p interpolated coefficient
+             jfotsout(indexint,3,auxi) = wm(i)*auxjo3p(ind+1) +
+     $            wp(i)*auxjo3p(ind)
+             !CO2 interpolated coefficient
+             jfotsout(indexint,1,auxi) = wm(i)*auxjco2(ind+1) +
+     $            wp(i)*auxjco2(ind)
+             !H2 interpolated coefficient
+             jfotsout(indexint,5,auxi) = wm(i)*auxjh2(ind+1) +
+     $            wp(i)*auxjh2(ind)
+             !N2 interpolated coefficient
+             jfotsout(indexint,8,auxi) = wm(i)*auxjn2(ind+1) +
+     $            wp(i)*auxjn2(ind)             
+             !CO interpolated coefficient
+             jfotsout(indexint,11,auxi) = wm(i)*auxjco(ind+1) +
+     $            wp(i)*auxjco(ind)
+             !H interpolated coefficient
+             jfotsout(indexint,12,auxi) = wm(i)*auxjh(ind+1) +
+     $            wp(i)*auxjh(ind)             
           enddo
-      end do
-      
-
-c**************************************************
-c     o3p, 5-80.5nm
-c**************************************************
-
-      do indexint=2,15
-         do i=1,nlayermx
-            aux2(nlayermx-i+1) = co2colx(i)*crscabsi2(1,indexint)+
-     $           o2colx(i)*crscabsi2(2,indexint)+
-     $           o3pcolx(i)*crscabsi2(3,indexint)+
-     $           h2colx(i)*crscabsi2(5,indexint)+
-     $           n2colx(i)*crscabsi2(8,indexint)+
-     $           ncolx(i)*crscabsi2(9,indexint)+
-     $           nocolx(i)*crscabsi2(10,indexint)+
-     $           cocolx(i)*crscabsi2(11,indexint)+
-     $           hcolx(i)*crscabsi2(12,indexint)+
-     $           no2colx(i)*crscabsi2(13,indexint)
-         end do
-         do i=1,nz2
-            aux3(i) = jabsifotsintpar(indexint,3,nz2-i+1)
-            aux4(i) = c1_16(nz2-i+1,indexint)
-         enddo
-         call interpfast 
-     $        (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
-         do i=1,nlayermx
-            jfotsout(indexint,3,i) = aux1(nlayermx-i+1)
-         enddo
-      end do
-
-c**************************************************
-c     co2, 5-80.5nm
-c**************************************************
-
-      do indexint=2,15
-         do i=1,nlayermx
-            aux2(nlayermx-i+1) = co2colx(i)*crscabsi2(1,indexint)+
-     $           o2colx(i)*crscabsi2(2,indexint)+
-     $           o3pcolx(i)*crscabsi2(3,indexint)+
-     $           h2colx(i)*crscabsi2(5,indexint)+
-     $           n2colx(i)*crscabsi2(8,indexint)+
-     $           ncolx(i)*crscabsi2(9,indexint)+
-     $           nocolx(i)*crscabsi2(10,indexint)+
-     $           cocolx(i)*crscabsi2(11,indexint)+
-     $           hcolx(i)*crscabsi2(12,indexint)+
-     $           no2colx(i)*crscabsi2(13,indexint)
-         end do
-         do i=1,nz2
-            aux3(i) = jabsifotsintpar(indexint,1,nz2-i+1)
-            aux4(i) = c1_16(nz2-i+1,indexint)
-         enddo
-         call interpfast 
-     $        (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
-         do i=1,nlayermx
-            jfotsout(indexint,1,i) = aux1(nlayermx-i+1)
-         enddo
-      end do
-
-
-c**************************************************
-c     h2, 5-80.5nm
-c**************************************************
-
-      do indexint=2,15
-         do i=1,nlayermx
-            aux2(nlayermx-i+1) = co2colx(i)*crscabsi2(1,indexint)+
-     $           o2colx(i)*crscabsi2(2,indexint)+
-     $           o3pcolx(i)*crscabsi2(3,indexint)+
-     $           h2colx(i)*crscabsi2(5,indexint)+
-     $           n2colx(i)*crscabsi2(8,indexint)+
-     $           ncolx(i)*crscabsi2(9,indexint)+
-     $           nocolx(i)*crscabsi2(10,indexint)+
-     $           cocolx(i)*crscabsi2(11,indexint)+
-     $           hcolx(i)*crscabsi2(12,indexint)+
-     $           no2colx(i)*crscabsi2(13,indexint)
-         end do
-         do i=1,nz2
-            aux3(i) = jabsifotsintpar(indexint,5,nz2-i+1)
-            aux4(i) = c1_16(nz2-i+1,indexint)
-         enddo
-         call interpfast 
-     $        (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
-         do i=1,nlayermx
-            jfotsout(indexint,5,i) = aux1(nlayermx-i+1)
-         enddo
-      end do
-
-
-c**************************************************
-c     n2, 5-80.5nm
-c**************************************************
-
-      do indexint=2,15
-         do i=1,nlayermx
-            aux2(nlayermx-i+1) = co2colx(i)*crscabsi2(1,indexint)+
-     $           o2colx(i)*crscabsi2(2,indexint)+
-     $           o3pcolx(i)*crscabsi2(3,indexint)+
-     $           h2colx(i)*crscabsi2(5,indexint)+
-     $           n2colx(i)*crscabsi2(8,indexint)+
-     $           ncolx(i)*crscabsi2(9,indexint)+
-     $           nocolx(i)*crscabsi2(10,indexint)+
-     $           cocolx(i)*crscabsi2(11,indexint)+
-     $           hcolx(i)*crscabsi2(12,indexint)+
-     $           no2colx(i)*crscabsi2(13,indexint)
-         end do
-         do i=1,nz2
-            aux3(i) = jabsifotsintpar(indexint,8,nz2-i+1)
-            aux4(i) = c1_16(nz2-i+1,indexint)
-         enddo
-         call interpfast 
-     $        (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
-         do i=1,nlayermx
-            jfotsout(indexint,8,i) = aux1(nlayermx-i+1)
-         enddo
-      end do
-
-
-c**************************************************
-c     co, 5-80.5nm
-c**************************************************
-
-      do indexint=2,15
-         do i=1,nlayermx
-            aux2(nlayermx-i+1) = co2colx(i)*crscabsi2(1,indexint)+
-     $           o2colx(i)*crscabsi2(2,indexint)+
-     $           o3pcolx(i)*crscabsi2(3,indexint)+
-     $           h2colx(i)*crscabsi2(5,indexint)+
-     $           n2colx(i)*crscabsi2(8,indexint)+
-     $           ncolx(i)*crscabsi2(9,indexint)+
-     $           nocolx(i)*crscabsi2(10,indexint)+
-     $           cocolx(i)*crscabsi2(11,indexint)+
-     $           hcolx(i)*crscabsi2(12,indexint)+
-     $           no2colx(i)*crscabsi2(13,indexint)
-         end do
-         do i=1,nz2
-            aux3(i) = jabsifotsintpar(indexint,11,nz2-i+1)
-            aux4(i) = c1_16(nz2-i+1,indexint)
-         enddo
-         call interpfast 
-     $        (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
-         do i=1,nlayermx
-            jfotsout(indexint,11,i) = aux1(nlayermx-i+1)
-         enddo
-      end do
-
-
-c**************************************************
-c     h, 5-80.5nm
-c**************************************************
-
-      do indexint=2,15
-         do i=1,nlayermx
-            aux2(nlayermx-i+1) = co2colx(i)*crscabsi2(1,indexint)+
-     $           o2colx(i)*crscabsi2(2,indexint)+
-     $           o3pcolx(i)*crscabsi2(3,indexint)+
-     $           h2colx(i)*crscabsi2(5,indexint)+
-     $           n2colx(i)*crscabsi2(8,indexint)+
-     $           ncolx(i)*crscabsi2(9,indexint)+
-     $           nocolx(i)*crscabsi2(10,indexint)+
-     $           cocolx(i)*crscabsi2(11,indexint)+
-     $           hcolx(i)*crscabsi2(12,indexint)+
-     $           no2colx(i)*crscabsi2(13,indexint)
-         end do
-         do i=1,nz2
-            aux3(i) = jabsifotsintpar(indexint,12,nz2-i+1)
-            aux4(i) = c1_16(nz2-i+1,indexint)
-         enddo
-         call interpfast 
-     $        (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
-         do i=1,nlayermx
-            jfotsout(indexint,12,i) = aux1(nlayermx-i+1)
-         enddo
-      end do
-
-
-      !Only if Nitrogen or ionospheric chemistry requested
-      if(chemthermod.ge.2) then
-c**************************************************
-c     n, 5-80.5nm
-c**************************************************
-
-         do indexint=2,15
-            do i=1,nlayermx
-               aux2(nlayermx-i+1) = co2colx(i)*crscabsi2(1,indexint)+
-     $              o2colx(i)*crscabsi2(2,indexint)+
-     $              o3pcolx(i)*crscabsi2(3,indexint)+
-     $              h2colx(i)*crscabsi2(5,indexint)+
-     $              n2colx(i)*crscabsi2(8,indexint)+
-     $              ncolx(i)*crscabsi2(9,indexint)+
-     $              nocolx(i)*crscabsi2(10,indexint)+
-     $              cocolx(i)*crscabsi2(11,indexint)+
-     $              hcolx(i)*crscabsi2(12,indexint)+
-     $              no2colx(i)*crscabsi2(13,indexint)
-            end do
-            do i=1,nz2
-               aux3(i) = jabsifotsintpar(indexint,9,nz2-i+1)
-               aux4(i) = c1_16(nz2-i+1,indexint)
-            enddo
-            call interpfast 
-     $           (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
-            do i=1,nlayermx
-               jfotsout(indexint,9,i) = aux1(nlayermx-i+1)
-            enddo
-         end do
-
-
-c**************************************************
-c     no, 5-80.5nm
-c**************************************************
-
-         do indexint=2,15
-            do i=1,nlayermx
-               aux2(nlayermx-i+1) = co2colx(i)*crscabsi2(1,indexint)+
-     $              o2colx(i)*crscabsi2(2,indexint)+
-     $              o3pcolx(i)*crscabsi2(3,indexint)+
-     $              h2colx(i)*crscabsi2(5,indexint)+
-     $              n2colx(i)*crscabsi2(8,indexint)+
-     $              ncolx(i)*crscabsi2(9,indexint)+
-     $              nocolx(i)*crscabsi2(10,indexint)+
-     $              cocolx(i)*crscabsi2(11,indexint)+
-     $              hcolx(i)*crscabsi2(12,indexint)+
-     $              no2colx(i)*crscabsi2(13,indexint)
-            end do
-            do i=1,nz2
-               aux3(i) = jabsifotsintpar(indexint,10,nz2-i+1)
-               aux4(i) = c1_16(nz2-i+1,indexint)
-            enddo
-            call interpfast 
-     $           (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
-            do i=1,nlayermx
-               jfotsout(indexint,10,i) = aux1(nlayermx-i+1)
-            enddo
-         end do
-
-c**************************************************
-c     no2, 5-80.5nm
-c**************************************************
-
-         do indexint=2,15
-            do i=1,nlayermx
-               aux2(nlayermx-i+1) = co2colx(i)*crscabsi2(1,indexint)+
-     $              o2colx(i)*crscabsi2(2,indexint)+
-     $              o3pcolx(i)*crscabsi2(3,indexint)+
-     $              h2colx(i)*crscabsi2(5,indexint)+
-     $              n2colx(i)*crscabsi2(8,indexint)+
-     $              ncolx(i)*crscabsi2(9,indexint)+
-     $              nocolx(i)*crscabsi2(10,indexint)+
-     $              cocolx(i)*crscabsi2(11,indexint)+
-     $              hcolx(i)*crscabsi2(12,indexint)+
-     $              no2colx(i)*crscabsi2(13,indexint)
-            end do
-            do i=1,nz2
-               aux3(i) = jabsifotsintpar(indexint,13,nz2-i+1)
-               aux4(i) = c1_16(nz2-i+1,indexint)
-            enddo
-            call interpfast 
-     $           (aux1,aux2,nlayermx,aux3,aux4,nz2,limdown,limup)
-            do i=1,nlayermx
-               jfotsout(indexint,13,i) = aux1(nlayermx-i+1)
-            enddo
-         end do
-      
-         endif  !Of chemthermod >= 2
-
-         
-c**************************************************
-c     o2, 80.6-90.8nm
-c**************************************************
-
+          !Only if chemthermod.ge.2
+          if(chemthermod.ge.2) then
+             do i=1,nlayermx
+                ind=auxind(i)
+                auxi = nlayermx-i+1
+                !N interpolated coefficient
+                jfotsout(indexint,9,auxi) = wm(i)*auxjn(ind+1) +
+     $               wp(i)*auxjn(ind)
+                !NO interpolated coefficient
+                jfotsout(indexint,10,auxi)=wm(i)*auxjno(ind+1) +
+     $               wp(i)*auxjno(ind)
+                !NO2 interpolated coefficient
+                jfotsout(indexint,13,auxi)=wm(i)*auxjno2(ind+1)+
+     $               wp(i)*auxjno2(ind)
+             enddo
+          endif   
+      end do
+
+c     End intervals 2-15
+
+
+ccccccccccccccccccccccccccccccc
+c     80.6-90.8nm (int16)
+c
+c     Absorption by:
+c     CO2, O2, O, N2, N, NO,
+c     CO, H, NO2
+ccccccccccccccccccccccccccccccc
+
+c     Input atmospheric column
       indexint=16
       do i=1,nlayermx
-         aux2(nlayermx-i+1) = co2colx(i)*crscabsi2(1,indexint)+
+         auxcolinp(nlayermx-i+1) = co2colx(i)*crscabsi2(1,indexint)+
      $        o2colx(i)*crscabsi2(2,indexint)+
      $        o3pcolx(i)*crscabsi2(3,indexint)+
